// TranspBitmapsDoc.cpp : implementation of the CTranspBitmapsDoc class
//

#include "stdafx.h"
#include "TranspBitmaps.h"

#include "TranspBitmapsDoc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CTranspBitmapsDoc

IMPLEMENT_DYNCREATE(CTranspBitmapsDoc, CDocument)

BEGIN_MESSAGE_MAP(CTranspBitmapsDoc, CDocument)
	//{{AFX_MSG_MAP(CTranspBitmapsDoc)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTranspBitmapsDoc construction/destruction

CTranspBitmapsDoc::CTranspBitmapsDoc()
{
	// TODO: add one-time construction code here

}

CTranspBitmapsDoc::~CTranspBitmapsDoc()
{
}

BOOL CTranspBitmapsDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;
	m_mainBmp.LoadBitmap(IDB_BITMAP1);
	m_ilBmp.LoadBitmap(IDB_BITMAP1);
	m_fgBmp.LoadBitmap(IDB_BITMAP2);
	m_bgBmp.LoadBitmap(IDB_BITMAP3);
	BITMAP bmp;
	m_mainBmp.GetBitmap(&bmp);
	m_mainSize=CSize(bmp.bmWidth, bmp.bmHeight);
	m_fgBmp.GetBitmap(&bmp);
	m_alphaSize=CSize(bmp.bmWidth, bmp.bmHeight);
	int m_alphaLen = bmp.bmWidthBytes;
	m_drawPoint = CPoint(10,10);
	imgList.Create(	m_mainSize.cx, 
					m_mainSize.cy, 
					ILC_COLOR24|ILC_MASK, 1, 0);
	imgList.Add(&m_ilBmp, RGB(255,255,255));
	CreateDIB();
	SetDrawType(1);		
	return TRUE;
}



/////////////////////////////////////////////////////////////////////////////
// CTranspBitmapsDoc serialization

void CTranspBitmapsDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		// TODO: add storing code here
	}
	else
	{
		// TODO: add loading code here
	}
}

/////////////////////////////////////////////////////////////////////////////
// CTranspBitmapsDoc diagnostics

#ifdef _DEBUG
void CTranspBitmapsDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CTranspBitmapsDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CTranspBitmapsDoc commands

void CTranspBitmapsDoc::SetDrawType(int type)
{
	m_drawType = type;
	UpdateAllViews(0);
}

inline bool isWhite(RGBTRIPLE *p)
{
	return ((p->rgbtRed==p->rgbtGreen) &&
			(p->rgbtBlue==p->rgbtGreen)&&
			(p->rgbtRed==255));
}

inline BYTE intensity(RGBTRIPLE *p)   //   ,   :)
{
	return (p->rgbtRed+p->rgbtGreen+p->rgbtBlue)/3;
}

void CTranspBitmapsDoc::CreateDIB()
{
	BITMAPINFO bmi;
	BITMAP bm;
	int sx, sy;

	HDC tempDC = GetDC(0);
	m_fgBmp.GetBitmap(&bm);
	sx = bm.bmWidth;
	sy = bm.bmHeight;
	bmi.bmiHeader.biSize = sizeof bmi.bmiHeader;
	bmi.bmiHeader.biWidth = sx;
	bmi.bmiHeader.biHeight = sy;
	bmi.bmiHeader.biPlanes = 1;
	bmi.bmiHeader.biBitCount = 32;
	bmi.bmiHeader.biCompression = BI_RGB;
	bmi.bmiHeader.biSizeImage = 0;
	RGBQUAD *buffer, pixel;
	RGBTRIPLE *t1, *t2;
	HBITMAP hDIB = CreateDIBSection(tempDC, &bmi, DIB_RGB_COLORS, 
									(void**)&buffer, 0, 0);
	bmi.bmiHeader.biBitCount=24;
	bmi.bmiHeader.biClrUsed=0;
	int widthBytes = sx*3 + (sx*3)%4;
	char* bits1 = new char[widthBytes*sy];
	char* bits2 = new char[widthBytes*sy];
	GetDIBits(tempDC, m_fgBmp, 0, sy, bits1, &bmi, DIB_RGB_COLORS);		
	GetDIBits(tempDC, m_bgBmp, 0, sy, bits2, &bmi, DIB_RGB_COLORS);		
	for (int i=0; i<sy; i++) 
	{
		t1 = (RGBTRIPLE*)(bits1+widthBytes*i);
		t2 = (RGBTRIPLE*)(bits2+widthBytes*i);
		for (int j=0; j<sx; j++)
		{
			if(isWhite(t1))
			{
				BYTE alpha=isWhite(t2)?0:255-intensity(t2)/2;
				pixel.rgbBlue  = alpha?t2->rgbtBlue/2:0;
				pixel.rgbGreen = alpha?t2->rgbtGreen/2:0;
				pixel.rgbRed   = alpha?t2->rgbtRed/2:0;
				pixel.rgbReserved = alpha;
			}
			else
			{
				pixel.rgbBlue  = t1->rgbtBlue;
				pixel.rgbGreen = t1->rgbtGreen;
				pixel.rgbRed   = t1->rgbtRed;
				pixel.rgbReserved = 255;
			}
			*buffer++ = pixel;
			t1++; t2++;
		}
	}
	m_alphaBmp.Attach(hDIB);
	ReleaseDC(0, tempDC);
	delete[] bits1;
	delete[] bits2;
}
